﻿using System.Windows.Forms;
using System.IO;

namespace SQL语句生成
{
    public partial class Main : Form
    {
        public Main()
        {
            InitializeComponent();
            text.Text = "表名&列名,int,备注|列名,nvarchar,备注|列名,bit,备注|列名,datetime,备注|列名,nvarchar,备注";
        }
        /// <summary>
        /// 生成SQL语句
        /// 日期20180422
        /// </summary>
        private void GenerateStatement()
        {
            //记录语句(合并要生成的SQL语句)
            string Statements = "";
            //源文本
            string _Source = text.Text;
            //分割源文本得到N个表的数据
            string[] _Sources = _Source.Trim().Replace("\r", "").Split('\n');
            foreach (string _Table in _Sources)
            {
                //把表名和列分离
                string[] _Tables = _Table.Split('&');
                //表名
                string TableName = _Tables[0];
                //所有列
                string[] Columns = _Tables[1].Split('|');

                //合并要生成的SQL语句
                Statements += "--表开始\r\n";
                Statements += "CREATE TABLE [dbo].[" + TableName + "](";
                Statements += "[" + Columns[0].Split(',')[0] + "] [int] IDENTITY(1,1) NOT NULL,\r\n";
                //合并要生成的SQL语句

                //循环进行新建列
                foreach (string _Columns in Columns)
                {
                    //忽略主键
                    if (_Columns == Columns[0])
                    {
                        //continue 跳过当次循环
                        //break 跳出当前循环
                        continue;
                    }

                    //列的数据
                    string[] columns = _Columns.Split(',');
                    //列名
                    string columnsName = columns[0];
                    //类型
                    string columnsType = columns[1];
                    //备注
                    //string columnsNote = columns[2];

                    //合并要生成的SQL语句
                    if (columnsType == "int")
                    {
                        Statements += "[" + columnsName + "] [int] NULL CONSTRAINT [DF_" + TableName + "_" + columnsName + "]  DEFAULT ((0)),\r\n";
                    }
                    else if (columnsType == "decimal")
                    {
                        Statements += "[" + columnsName + "] [decimal](18, 0) NULL CONSTRAINT [DF_" + TableName + "_" + columnsName + "]  DEFAULT ((0)),\r\n";
                    }
                    else if (columnsType == "nvarchar")
                    {
                        Statements += "[" + columnsName + "] [nvarchar](max) NULL CONSTRAINT [DF_" + TableName + "_" + columnsName + "]  DEFAULT (' '),\r\n";
                    }
                    else if (columnsType == "bit")
                    {
                        Statements += "[" + columnsName + "] [bit] NULL CONSTRAINT [DF_" + TableName + "_" + columnsName + "]  DEFAULT ((0)),\r\n";
                    }
                    else if (columnsType == "datetime")
                    {
                        Statements += "[" + columnsName + "] [datetime] NULL CONSTRAINT [DF_" + TableName + "_" + columnsName + "]  DEFAULT (getdate()),\r\n";
                    }
                    else if (columnsType == "image")
                    {
                        Statements += "[" + columnsName + "] [image] NULL CONSTRAINT [DF_" + TableName + "_" + columnsName + "]  DEFAULT (' '),\r\n";
                    }
                    //合并要生成的SQL语句

                }

                //合并要生成的SQL语句
                Statements += "CONSTRAINT [PK_FDJZ_"+ TableName + "] PRIMARY KEY CLUSTERED (" + Columns[0].Split(',')[0] + " ASC)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]) ON [PRIMARY]\r\n";
                //合并要生成的SQL语句

                //循环对列进行备注
                foreach (string _Columns in Columns)
                {
                    //列的数据
                    string[] columns = _Columns.Split(',');
                    //列名
                    string columnsName = columns[0];
                    //类型
                    //string columnsType = columns[1];
                    //备注
                    string columnsNote = columns[2];

                    //合并要生成的SQL语句
                    Statements += "GO\r\n";
                    Statements += "EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'"+ columnsNote + "' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'" + TableName + "', @level2type=N'COLUMN',@level2name=N'" + columnsName + "'\r\n";
                    //合并要生成的SQL语句
                }
            }
            File.AppendAllText("Statements.sql", Statements);
            MessageBox.Show("完成生成");
        }
        /// <summary>
        /// 按键启动生成
        /// </summary>
        private void Main_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.F5) GenerateStatement();
            if (e.KeyCode == Keys.F10) new GoText(text).Show();
        }
    }
}
